Index: src/molecule_graph.cpp
===================================================================
--- src/molecule_graph.cpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/molecule_graph.cpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -1046,5 +1096,5 @@
     //Log() << Verbose(0) << endl;
   } else {
-    Log() << Verbose(0) << "Number of bonds for Atom " << *Walker << " does not match, parsed " << CurrentBondsOfAtom << " against " << Walker->ListOfBonds.size() << "." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Number of bonds for Atom " << *Walker << " does not match, parsed " << CurrentBondsOfAtom << " against " << Walker->ListOfBonds.size() << "." << endl);
     status = false;
   }
@@ -1069,5 +1119,5 @@
 
   if (!CheckAdjacencyFileAgainstMolecule_Init(path, File, CurrentBonds)) {
-    Log() << Verbose(1) << "Adjacency file not found." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "Adjacency file not found." << endl);
     return true;
   }
@@ -1095,7 +1145,7 @@
 
   if (status) { // if equal we parse the KeySetFile
-    Log() << Verbose(1) << "done: Equal." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "done: Equal." << endl);
   } else
-    Log() << Verbose(1) << "done: Not equal by " << NonMatchNumber << " atoms." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "done: Not equal by " << NonMatchNumber << " atoms." << endl);
   return status;
 }
@@ -1113,5 +1163,5 @@
   bool status = true;
   if (ReferenceStack->IsEmpty()) {
-    eLog() << Verbose(0) << "ReferenceStack is empty!" << endl;
+    DoLog(1) && (Log() << Verbose(1) << "ReferenceStack is empty!" << endl);
     return false;
   }
@@ -1128,10 +1178,10 @@
         if (OtherAtom == ListOfLocalAtoms[(*Runner)->rightatom->nr]) { // found the bond
           LocalStack->Push((*Runner));
-          Log() << Verbose(3) << "Found local edge " << *(*Runner) << "." << endl;
+          DoLog(3) && (Log() << Verbose(3) << "Found local edge " << *(*Runner) << "." << endl);
           break;
         }
       }
     Binder = ReferenceStack->PopFirst(); // loop the stack for next item
-    Log() << Verbose(3) << "Current candidate edge " << Binder << "." << endl;
+    DoLog(3) && (Log() << Verbose(3) << "Current candidate edge " << Binder << "." << endl);
     ReferenceStack->Push(Binder);
   } while (FirstBond != Binder);
@@ -1182,21 +1232,21 @@
   BFS.PredecessorList[OtherAtom->nr] = Walker; // Walker is the predecessor
   BFS.ShortestPathList[OtherAtom->nr] = BFS.ShortestPathList[Walker->nr] + 1;
-  Log() << Verbose(2) << "Coloring OtherAtom " << OtherAtom->Name << " " << ((BFS.ColorList[OtherAtom->nr] == white) ? "white" : "lightgray") << ", its predecessor is " << Walker->Name << " and its Shortest Path is " << BFS.ShortestPathList[OtherAtom->nr] << " egde(s) long." << endl;
+  DoLog(2) && (Log() << Verbose(2) << "Coloring OtherAtom " << OtherAtom->Name << " " << ((BFS.ColorList[OtherAtom->nr] == white) ? "white" : "lightgray") << ", its predecessor is " << Walker->Name << " and its Shortest Path is " << BFS.ShortestPathList[OtherAtom->nr] << " egde(s) long." << endl);
   if ((((BFS.ShortestPathList[OtherAtom->nr] < BFS.BondOrder) && (Binder != Bond)))) { // Check for maximum distance
-    Log() << Verbose(3);
+    DoLog(3) && (Log() << Verbose(3));
     if (AddedAtomList[OtherAtom->nr] == NULL) { // add if it's not been so far
       AddedAtomList[OtherAtom->nr] = Mol->AddCopyAtom(OtherAtom);
-      Log() << Verbose(0) << "Added OtherAtom " << OtherAtom->Name;
+      DoLog(0) && (Log() << Verbose(0) << "Added OtherAtom " << OtherAtom->Name);
       AddedBondList[Binder->nr] = Mol->CopyBond(AddedAtomList[Walker->nr], AddedAtomList[OtherAtom->nr], Binder);
-      Log() << Verbose(0) << " and bond " << *(AddedBondList[Binder->nr]) << ", ";
+      DoLog(0) && (Log() << Verbose(0) << " and bond " << *(AddedBondList[Binder->nr]) << ", ");
     } else { // this code should actually never come into play (all white atoms are not yet present in BondMolecule, that's why they are white in the first place)
-      Log() << Verbose(0) << "Not adding OtherAtom " << OtherAtom->Name;
+      DoLog(0) && (Log() << Verbose(0) << "Not adding OtherAtom " << OtherAtom->Name);
       if (AddedBondList[Binder->nr] == NULL) {
         AddedBondList[Binder->nr] = Mol->CopyBond(AddedAtomList[Walker->nr], AddedAtomList[OtherAtom->nr], Binder);
-        Log() << Verbose(0) << ", added Bond " << *(AddedBondList[Binder->nr]);
+        DoLog(0) && (Log() << Verbose(0) << ", added Bond " << *(AddedBondList[Binder->nr]));
       } else
-        Log() << Verbose(0) << ", not added Bond ";
-    }
-    Log() << Verbose(0) << ", putting OtherAtom into queue." << endl;
+        DoLog(0) && (Log() << Verbose(0) << ", not added Bond ");
+    }
+    DoLog(0) && (Log() << Verbose(0) << ", putting OtherAtom into queue." << endl);
     BFS.BFSStack->Push(OtherAtom);
   } else { // out of bond order, then replace
@@ -1204,9 +1254,9 @@
       BFS.ColorList[OtherAtom->nr] = white; // unmark if it has not been queued/added, to make it available via its other bonds (cyclic)
     if (Binder == Bond)
-      Log() << Verbose(3) << "Not Queueing, is the Root bond";
+      DoLog(3) && (Log() << Verbose(3) << "Not Queueing, is the Root bond");
     else if (BFS.ShortestPathList[OtherAtom->nr] >= BFS.BondOrder)
-      Log() << Verbose(3) << "Not Queueing, is out of Bond Count of " << BFS.BondOrder;
+      DoLog(3) && (Log() << Verbose(3) << "Not Queueing, is out of Bond Count of " << BFS.BondOrder);
     if (!Binder->Cyclic)
-      Log() << Verbose(0) << ", is not part of a cyclic bond, saturating bond with Hydrogen." << endl;
+      DoLog(0) && (Log() << Verbose(0) << ", is not part of a cyclic bond, saturating bond with Hydrogen." << endl);
     if (AddedBondList[Binder->nr] == NULL) {
       if ((AddedAtomList[OtherAtom->nr] != NULL)) { // .. whether we add or saturate
@@ -1225,5 +1275,5 @@
 void BreadthFirstSearchAdd_VisitedNode(molecule *Mol, struct BFSAccounting &BFS, atom *&Walker, atom *&OtherAtom, bond *&Binder, bond *&Bond, atom **&AddedAtomList, bond **&AddedBondList, bool IsAngstroem)
 {
-  Log() << Verbose(3) << "Not Adding, has already been visited." << endl;
+  DoLog(3) && (Log() << Verbose(3) << "Not Adding, has already been visited." << endl);
   // This has to be a cyclic bond, check whether it's present ...
   if (AddedBondList[Binder->nr] == NULL) {
@@ -1271,10 +1321,10 @@
     // followed by n+1 till top of stack.
     Walker = BFS.BFSStack->PopFirst(); // pop oldest added
-    Log() << Verbose(1) << "Current Walker is: " << Walker->Name << ", and has " << Walker->ListOfBonds.size() << " bonds." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "Current Walker is: " << Walker->Name << ", and has " << Walker->ListOfBonds.size() << " bonds." << endl);
     for (BondList::const_iterator Runner = Walker->ListOfBonds.begin(); Runner != Walker->ListOfBonds.end(); (++Runner)) {
       if ((*Runner) != NULL) { // don't look at bond equal NULL
         Binder = (*Runner);
         OtherAtom = (*Runner)->GetOtherAtom(Walker);
-        Log() << Verbose(2) << "Current OtherAtom is: " << OtherAtom->Name << " for bond " << *(*Runner) << "." << endl;
+        DoLog(2) && (Log() << Verbose(2) << "Current OtherAtom is: " << OtherAtom->Name << " for bond " << *(*Runner) << "." << endl);
         if (BFS.ColorList[OtherAtom->nr] == white) {
           BreadthFirstSearchAdd_UnvisitedNode(Mol, BFS, Walker, OtherAtom, Binder, Bond, AddedAtomList, AddedBondList, IsAngstroem);
@@ -1285,5 +1335,5 @@
     }
     BFS.ColorList[Walker->nr] = black;
-    Log() << Verbose(1) << "Coloring Walker " << Walker->Name << " black." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "Coloring Walker " << Walker->Name << " black." << endl);
   }
   BreadthFirstSearchAdd_Free(BFS);
@@ -1310,5 +1360,5 @@
   // reset parent list
   ParentList = Calloc<atom*> (AtomCount, "molecule::BuildInducedSubgraph_Init: **ParentList");
-  Log() << Verbose(3) << "Resetting ParentList." << endl;
+  DoLog(3) && (Log() << Verbose(3) << "Resetting ParentList." << endl);
 }
 ;
@@ -1317,5 +1367,5 @@
 {
   // fill parent list with sons
-  Log() << Verbose(3) << "Filling Parent List." << endl;
+  DoLog(3) && (Log() << Verbose(3) << "Filling Parent List." << endl);
   atom *Walker = mol->start;
   while (Walker->next != mol->end) {
@@ -1323,5 +1373,5 @@
     ParentList[Walker->father->nr] = Walker;
     // Outputting List for debugging
-    Log() << Verbose(4) << "Son[" << Walker->father->nr << "] of " << Walker->father << " is " << ParentList[Walker->father->nr] << "." << endl;
+    DoLog(4) && (Log() << Verbose(4) << "Son[" << Walker->father->nr << "] of " << Walker->father << " is " << ParentList[Walker->father->nr] << "." << endl);
   }
 
@@ -1341,5 +1391,5 @@
   atom *OtherAtom = NULL;
   // check each entry of parent list and if ok (one-to-and-onto matching) create bonds
-  Log() << Verbose(3) << "Creating bonds." << endl;
+  DoLog(3) && (Log() << Verbose(3) << "Creating bonds." << endl);
   Walker = Father->start;
   while (Walker->next != Father->end) {
@@ -1352,5 +1402,5 @@
           OtherAtom = (*Runner)->GetOtherAtom(Walker);
           if (ParentList[OtherAtom->nr] != NULL) { // if otheratom is also a father of an atom on this molecule, create the bond
-            Log() << Verbose(4) << "Endpoints of Bond " << (*Runner) << " are both present: " << ParentList[Walker->nr]->Name << " and " << ParentList[OtherAtom->nr]->Name << "." << endl;
+            DoLog(4) && (Log() << Verbose(4) << "Endpoints of Bond " << (*Runner) << " are both present: " << ParentList[Walker->nr]->Name << " and " << ParentList[OtherAtom->nr]->Name << "." << endl);
             mol->AddBond(ParentList[Walker->nr], ParentList[OtherAtom->nr], (*Runner)->BondDegree);
           }
@@ -1377,10 +1427,10 @@
   atom **ParentList = NULL;
 
-  Log() << Verbose(2) << "Begin of BuildInducedSubgraph." << endl;
+  DoLog(2) && (Log() << Verbose(2) << "Begin of BuildInducedSubgraph." << endl);
   BuildInducedSubgraph_Init(ParentList, Father->AtomCount);
   BuildInducedSubgraph_FillParentList(this, Father, ParentList);
   status = BuildInducedSubgraph_CreateBondsFromParent(this, Father, ParentList);
   BuildInducedSubgraph_Finalize(ParentList);
-  Log() << Verbose(2) << "End of BuildInducedSubgraph." << endl;
+  DoLog(2) && (Log() << Verbose(2) << "End of BuildInducedSubgraph." << endl);
   return status;
 }
@@ -1399,6 +1449,6 @@
   int size;
 
-  Log() << Verbose(1) << "Begin of CheckForConnectedSubgraph" << endl;
-  Log() << Verbose(2) << "Disconnected atom: ";
+  DoLog(1) && (Log() << Verbose(1) << "Begin of CheckForConnectedSubgraph" << endl);
+  DoLog(2) && (Log() << Verbose(2) << "Disconnected atom: ");
 
   // count number of atoms in graph
@@ -1422,15 +1472,15 @@
       }
       if (!BondStatus) {
-        Log() << Verbose(0) << (*Walker) << endl;
+        DoLog(0) && (Log() << Verbose(0) << (*Walker) << endl);
         return false;
       }
     }
   else {
-    Log() << Verbose(0) << "none." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "none." << endl);
     return true;
   }
-  Log() << Verbose(0) << "none." << endl;
-
-  Log() << Verbose(1) << "End of CheckForConnectedSubgraph" << endl;
+  DoLog(0) && (Log() << Verbose(0) << "none." << endl);
+
+  DoLog(1) && (Log() << Verbose(1) << "End of CheckForConnectedSubgraph" << endl);
 
   return true;
Index: src/molecule_pointcloud.cpp
===================================================================
--- src/molecule_pointcloud.cpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/molecule_pointcloud.cpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -13,4 +13,11 @@
 /************************************* Functions for class molecule *********************************/
 
+/** Returns a name for this point cloud, here the molecule's name.
+ * \return name of point cloud
+ */
+const char * const molecule::GetName() const
+{
+  return name;
+};
 
 /** Determine center of all atoms.
@@ -41,4 +48,12 @@
 {
   return end;
+};
+
+/** Return the greatest index of all atoms in the list.
+ * \return greatest index
+ */
+int molecule::GetMaxId() const
+{
+  return last_atom;
 };
 
